/*

	semaphore.h  -  header file to semaphore.c

    Copyright (C) 2007  J. op den Brouw <jesse@opdenbrouw.nl>

	This file is part of jrtos version 0.2

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/


#ifndef _SEMAPHORE_H_
#define _SEMAPHORE_H_

#include <avr/interrupt.h>
#include <avr/io.h>
#include <stdint.h>

/* Needed for sem_yield() */
#include "process.h"

/* Define tricky routine. */
#define SEM_ROUTINE_TRICKY

/* Currently, a semaphore can hold up to one byte. */
typedef uint8_t semaphore;

/* Prototypes for the three possible semphore functions. */
void init_sem(semaphore *ps, uint8_t value);
void up(semaphore *ps);
void down(semaphore *ps);

#endif
